﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web.Http;

using System.IO;
using System.Web;
using System.Net.Http;
using System.Net.Http.Headers;
namespace Save_Files_Database_EF_MVC.Controllers
{
public class FileAPIController : ApiController
{
    [HttpPost]
    [Route("api/FileAPI/SaveFile")]
    public HttpResponseMessage SaveFile()
    {
        //Create HTTP Response.
        HttpResponseMessage response = Request.CreateResponse(HttpStatusCode.OK);

        //Check if Request contains File.
        if (HttpContext.Current.Request.Files.Count == 0)
        {
            throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
        }

        //Read the File data from Request.Form collection.
        HttpPostedFile postedFile = HttpContext.Current.Request.Files[0];

        //Fetch the File Name.
        string fileName = Path.GetFileName(postedFile.FileName);

        //Set the File Path.
        string filePath = @"D:\SavedFiles\" + fileName;

        //Save the File in Folder.
        postedFile.SaveAs(filePath);

        //Insert the File to Database Table.
        FilesEntities entities = new FilesEntities();
        File file = new File
        {
            Name = fileName,
            Path = filePath
        };
        entities.Files.Add(file);
        entities.SaveChanges();

        return Request.CreateResponse(HttpStatusCode.OK, new { id = file.FileId, Name = file.Name });
    }

    [HttpPost]
    [Route("api/FileAPI/GetFiles")]
    public HttpResponseMessage GetFiles()
    {
        FilesEntities entities = new FilesEntities();
        var files = from file in entities.Files
                    select new { id = file.FileId, Name = file.Name };
        return Request.CreateResponse(HttpStatusCode.OK, files);
    }

    [HttpGet]
    [Route("api/FileAPI/GetFile")]
    public HttpResponseMessage GetFile(int fileId)
    {
        //Create HTTP Response.
        HttpResponseMessage response = Request.CreateResponse(HttpStatusCode.OK);

        //Fetch the File data from Database.
        FilesEntities entities = new FilesEntities();
        File file = entities.Files.ToList().Find(p => p.FileId == fileId);

        //Read the File as Byte Array from Folder.
        byte[] fileData = System.IO.File.ReadAllBytes(@"D:\SavedFiles\" + file.Name);

        //Set the Response Content.
        response.Content = new ByteArrayContent(fileData);

        //Set the Response Content Length.
        response.Content.Headers.ContentLength = fileData.LongLength;

        //Set the Content Disposition Header Value and FileName.
        response.Content.Headers.ContentDisposition = new ContentDispositionHeaderValue("attachment");
        response.Content.Headers.ContentDisposition.FileName = file.Name;

        //Set the File Content Type.
        response.Content.Headers.ContentType = new MediaTypeHeaderValue("application/octet-stream");
        return response;
    }
}
}
